// Multi-dimensional Array Iteration using for(;;) loop
public class MultidimArrayIteration {

  public static void main(String[] args) {

    int[][] weeklyData = { // Declaration, creation and initialisation.
        {12, 10, 22, 33, 19, 27, 16},  // 1st mobile phone
        {45, 55, 44, 34, 39, 15, 11},  // 2nd mobile phone
        {18, 26, 36, 40, 24, 11, 20}   // 3rd mobile phone
      };

    // Problem (1) Print the data in tabular form
    for (int phoneIndex = 0;
         phoneIndex < weeklyData.length;
         phoneIndex++) {
      System.out.print("Phone index " + phoneIndex + ": ");
      for (int dayIndex = 0;
           dayIndex < weeklyData[phoneIndex].length;
           dayIndex++) {
        System.out.printf("%4d", weeklyData[phoneIndex][dayIndex]);
      }
      System.out.println();
    }

    // Problem (2) Find the total number of text messages sent from
    // the mobile phone indicated by index 1
    int sumWeek = 0;
    for (int dayIndex = 0; dayIndex < weeklyData[1].length; dayIndex++) {
      sumWeek += weeklyData[1][dayIndex];
    }
    System.out.println(
      "Total no. of text messages sent from the mobile phone given" +
      " by index 1: " + sumWeek);

    // Problem (3) Find the total number of text messages sent from all
    // mobile phones on Wednesday (day index 2)
    int sumMessages = 0;
    for (int phoneIndex = 0;
         phoneIndex < weeklyData.length;
         phoneIndex++) {
      sumMessages += weeklyData[phoneIndex][2];
    }
    System.out.println(
      "Total no. of text messages sent from all mobile phones on" +
      " Wednesday: " + sumMessages);

    // Problem (4) Find which days the total no. of text messages sent
    // from all mobile phones is greater than 100.
    for (int dayIndex = 0; dayIndex < weeklyData[0].length; dayIndex++) {
      int sumDays = 0;
      for (int phoneIndex = 0;
           phoneIndex < weeklyData.length;
           phoneIndex++) {
        sumDays += weeklyData[phoneIndex][dayIndex];
      }
      if (sumDays > 100) {
        System.out.println("The day with index " + dayIndex +
                           " has over 100 text messages registered.");
      }
    }
  }
}