// Using program arguments
public class Client4B {

  public static void main(String[] args) {

    // (1) Check that all information about an employee is given
    //     on the command line:
    if (args.length != 4) {
      return;
    }

 	// (2) Print the array args:
    System.out.println("Program arguments:");
    for (String arg : args) {
      System.out.println(arg);
    }

    // (3) Assign information from the array args to local variables:
    String firstName = args[0];
    String lastName = args[1];
    double hourlyRate = Double.parseDouble(args[2]); // (4) Floating-point
    boolean gender;
    if (args[3].equals("true")) {                    // (5) Boolean value
      gender = EmployeeV4.FEMALE;
    } else {
      gender = EmployeeV4.MALE;
    }

    // (6) Create an employee, and print its state:
    EmployeeV4 decorator = new EmployeeV4();
    decorator.setState(firstName, lastName, hourlyRate, gender);
    System.out.println("Information about an employee:");
    decorator.printState();
    System.out.printf("Salary: %.2f%n", decorator.computeSalary(40.0));
  }
}