
class SmallCompany {
  Employee president;
  Employee cfo;  // Chief financial officer
  Employee cto;  // Chief technology officer
  Employee engineer;

  TextUserInterface ui;

  SmallCompany(TextUserInterface ui) {
    this.ui = ui;

    president = new Employee("Norman", "Knuth", 37, Gender.MALE);
    cfo = new Employee("Steven", "Feynman", 30, Gender.MALE);
    cto = new Employee("Donald", "Borlaug", 32, Gender.MALE);
    engineer = new Employee("Richard", "Levy", 24, Gender.MALE);

    cfo.manager = president;
    cto.manager = president;
    engineer.manager = cto;
  }

  void reportIncomeDifferenceWithManager(Employee anEmployee) {
    Employee manager = anEmployee.manager;
    assert manager != null;
    double income_difference =
      manager.computeSalary(Employee.NORMAL_WORKWEEK)
      - anEmployee.computeSalary(Employee.NORMAL_WORKWEEK);
    ui.reportIncomeDifference(anEmployee, manager, income_difference);
  }
}

public class Managers {
  public static void main(String[] args) {
    TextUserInterface ui = new TextUserInterface();                // (1)
    SmallCompany company = new SmallCompany(ui);                   // (2)
    company.reportIncomeDifferenceWithManager(company.cfo);        // (3)
    company.reportIncomeDifferenceWithManager(company.engineer);   // (4)
  }
}