import java.util.Scanner;

class TextUserInterface {
  Scanner input = new Scanner(System.in);

  String requestString(String wantedInfo) {
    System.out.printf("- %s: ", wantedInfo);
    return input.nextLine();
  }

  double requestDouble(String wantedInfo) {
    System.out.printf("- %s: ", wantedInfo);
    double value = input.nextDouble();
    input.nextLine(); // skip the rest of the line
    return value;
  }

  boolean requestYesNoAnswer(String wantedInfo) {
    String answer = requestString(wantedInfo + " (y/n)");
    return answer.equals("y");
  }

  Employee inputEmployee(String label, boolean inputGender) {
    System.out.printf("Input information about %s:\n", label);
    String firstName = requestString("First name");
    String lastName = requestString("Last name");
    double hourlyRate = requestDouble("Hourly rate");
    Gender gender = Gender.UNKNOWN;

    if (inputGender) {
      gender = requestGender();
    }

    return new Employee(firstName, lastName, hourlyRate, gender);
  }

  Gender requestGender() {
    if (requestYesNoAnswer("Is this a woman?")) {
      return Gender.FEMALE;
    }

    return Gender.MALE;
  }

  void reportSameHourlyRate(double hourlyRate) {
    System.out.printf("Both earn $%.2f per hour.\n", hourlyRate);
  }

  void reportHigherHourlyRate(Employee employee) {
    System.out.printf("%s %s has the higher hourly rate: $%.2f "
                      + "per hour.\n",
                      employee.firstName,
                      employee.lastName,
                      employee.hourlyRate);
  }

  void reportIncomeDifference(Employee employee, Employee manager,
            double income_difference) {
    System.out.printf("%s %s earns $%.2f less than the manager %s %s "
                      + "during a normal work week\n",
                      employee.firstName, employee.lastName,
                      income_difference,
                      manager.firstName, manager.lastName);
  }

  void reportPercentageWomen(int employeeCount, double percentageWomen) {
    System.out.printf("The company has %d employees, %.1f%% of which are "
                      + "women.\n", employeeCount, percentageWomen);
  }
}