// A simple CD class that can be ordered by artist, title and release year.
class CD2 implements Comparable {
  // Declaration of field variables
  String artist;
  String title;
  int    released;
  double price;

  // Creates a new CD with given artist, title, release year and price.
  CD2(String artist, String title, int released, double price) {
    this.artist = artist;
    this.title = title;
    this.released = released;
    this.price = price;
  }

  // Returns a string representation of the CD.
  public String toString () {
    return "CD: " + artist + " - '" + title + "' (" + released + ")"
           + " with price " + price;
  }

  // Determines if two CDs are equal, i.e. have the 
  // same artist, title and release year.
  public boolean equals(Object obj) {   // (1)
    if (this == obj)                    // (2) Aliases?
      return true;
    if (!(obj instanceof CD2))          // (3) Has correct type?
      return false;
    return compareTo(obj) == 0 ;        // (4)
  }

  // Compares two CDs with respect to artist, title and release year.
  public int compareTo(Object obj) {     // (5)
    CD2 otherCD = (CD2) obj;
    int status = artist.compareTo(otherCD.artist);
    if (status == 0) {                   // Same artist, rank by title
      status = title.compareTo(otherCD.title);
      if (status == 0) {                 // Same title, rank by release
       return released - otherCD.released;
      }
    }
    return status;                       // Ranked either by artist or title
  }
}