/**
* Class representing a move in the game of Nim.
*/
 class Move {
    private int chosenNumberOfSticks, chosenRowNumber;
    /**
     * Constructor that sets the row and number of sticks for the move.
     * @param requestedNumberOfSticks - indicates how many sticks to be removed
     * @param requestedRowNumber - indicates the row these sticks should be taken from
     */
    public Move(int requestedNumberOfSticks, int requestedRowNumber) {
        chosenNumberOfSticks = requestedNumberOfSticks;
        chosenRowNumber = requestedRowNumber;
    }

    /**
     * The method returns the number of sticks of the move.
     */
    public int getNumSticks(){
        return chosenNumberOfSticks;
    }

    /**
     * The method returns the row number affected by the move.
     */
    public int getRowNumber() {
        return chosenRowNumber;
    }
}