import java.util.Scanner;
/**
 * Class representing a player controlled by the user.
 */
class RealPlayer extends BasicPlayer{
  String name;
  public static Scanner keyboard = new Scanner(System.in);

  // The constructor asks for player's name
  public RealPlayer() {
    System.out.println("What's your name?");
    name = keyboard.next();
  }

  /**
   * Method returning the name of the player
   * @return String - name of the player
   */
  public String getName() {
    return name;
  }

  /**
   * Method asking the user for which move he/she wants to do, and
   * returns this.
   * @return Move - the move chosen by the user
   */
  public Move nextMove(int rows[]) {
    int sticks,row;
    System.out.println(name + ", how many sticks do you want to remove?");
    sticks = keyboard.nextInt();
    while(sticks < 1){
      System.out.println("You must remove at least one stick");
      sticks=keyboard.nextInt();
    }
    System.out.println(name + ", which row do you want to remove sticks from?");
    row = keyboard.nextInt();
    while(row < 0){
      System.out.println("You must choose a valid row number");
      row=keyboard.nextInt();
    }
    Move theMove = new Move(sticks, row);
    return theMove;
  }
}