import java.util.Scanner;
/**
 * Calculates the weekly salary of an employee or a manager, depending on
 * user input.
 */
class ReferenceConversion {
  public static void main(String[] args) {
    EmployeeV0 employee;
    Scanner keyboard = new Scanner(System.in);

    // Chooses which type of employee to create
    System.out.println("Types of employees:");
    System.out.println(" 1 - Employee");
    System.out.println(" 2 - Manager");
    System.out.print("Choose a category: ");
    int empCode = keyboard.nextInt();

    // Creates an employee of the chosen type
    switch(empCode){
      case 1: employee = new EmployeeV0("John", "Doe", 30.0);
              break;
      case 2: employee = new ManagerV0("Hector", "Vee", 55.0, 95.0);  // (1)
              break;
      default: System.out.println("Invalid category - creating an Employee");
               employee = new EmployeeV0("John", "Smith", 25.0);
               break;
    }

    // Prints a report for the employee
    System.out.println("Printing information:");
    // Prints properties common to all types of employees
    employee.printState();                                            // (2)
    // Prints subclass specific data for managers
    if (employee instanceof ManagerV0) {                              // (3)
      ManagerV0 manager = (ManagerV0) employee;                       // (4)
      System.out.printf("Manager bonus is %.2f GBP%n",
                        manager.managerBonus);                        // (5)
    }
  }
}