/**
 * Retrieves inherited state and uses inherited behaviour in the subclass.
 */
class UseInheritance {
  public static void main(String[] args) {
    double numOfHoursWorked = 50.5;
    // Creating a manager object
    ManagerV0 manager = new ManagerV0("John D.", "Boss", 60.0);

    // Refers to subclass field by field name
    manager.managerBonus= 650.0;

    // Refers to inherited and subclass fields by field names
    System.out.printf("Manager %s has a bonus of %.2f GBP%n",
                       manager.lastName, manager.managerBonus);

    // Calls subclass instance methods by method names
    System.out.printf("Manager salary is %.2f GBP%n",
                       manager.calculateManagerSalary(numOfHoursWorked));

    // Calls inherited instance method by method name
    manager.printState();

    // Refers to inherited static variable
    System.out.printf("Normal work week is %.1f hours%n",
                       manager.NORMAL_WORKWEEK);                // (1)
    if (numOfHoursWorked > ManagerV0.NORMAL_WORKWEEK) {         // (2)
      System.out.printf("Overtime: %.1f hours%n",
            (numOfHoursWorked - EmployeeV0.NORMAL_WORKWEEK));   // (3)
    } else {
      System.out.println("No overtime.");
    }
  }
}