// (1) An interface
interface IClubMember {
  double feePercentage = 0.012;
  double calculateFee(double sum) {
    feePercentage += 0.002;
    return feePercentage*sum;
  }
}

// (2) Class implementing the interface
class Worker implements IClubMember {
  public double calculateFee(double annualSalary) {
    feePercentage += 0.001;
    return feePercentage*annualSalary;
  }
  double getFeePercentage() { return feePercentage; }
}

// (3) Client using an interface reference
public class ClubClient {
  public static void main(String[] args) {
    IClubMember member = new IClubMember();
    IClubMember worker = new Worker();
    System.out.printf("Fee: %.2f GBP%n", worker.calculateFee(35000.0));
    System.out.printf("Percentage: %d%n", worker.getFeePercentage());
  }
}