interface IUnionMember {
  // Constants
  int SUBORDINATE = 1;
  int MIDDLE_MANAGEMENT = 2;
  int UPPER_MANAGEMENT = 3;
//  enum MemberCategory {SUBORDINATE, MIDDLE_MANAGEMENT,UPPER_MANAGEMENT};

  // Contract for behaviour
  /**
   * Calculates the union fee based on weekly salary and employee category.
   * @pre weeklySalary >= 0.0 && (empCategory == SUBORDINATE ||
   *      empCategory == MIDDLE_MANAGEMENT || empCategory == UPPER_MANAGEMENT)
   * @post return >= 0.0
   */
  double calculateFee(double weeklySalary, int empCategory);
}