final class PermanentEmployee extends EmployeeVA {
  // Constructor
  public PermanentEmployee(String firstName, String lastName, double rate) {
    super(firstName, lastName, rate);
  }

  // Instance method
  /**
   * Calculates the weekly salary for the employee.
   * This method implements the abstract method in the EmployeeVA class.
   * @param numHours Number of hours worked in current week.
   * @return Weekly salary in GBP for the current week.
   */
  public double calculateSalary(double numHours) {
    assert numHours >= 0 : "Number of hours must be >= 0"; // @pre
    double salary = NORMAL_WORKWEEK * hourlyRate;
    assert salary >= 0.0 : "Weekly salary must be >= 0.0"; // @post
    return salary;
  }
}