/**
 * Calculating employee salaries and simple statistics.
 */
public class SalaryClient {
  public static void main(String[] args) {
    // Creates an array of different types of employees
    Employee[] empArray = {
        new Employee("John", "Doe", 30.0),
        new Manager("Kim", "Brown", 55.0, 235.0),
        new HourlyWorker("Mary", "Smith", 35.0),
        new Manager("John D.", "Boss", 60.0, 105.0),
        new PieceWorker("Ken", "Jones", 12.5, 75)
    };

    // Problem 1:
    // Calculates and prints the weekly salary for each employee.
    // Calculates and prints the total amount paid out in salaries.
    double empSalary;
    double sumSalaries = 0.0;
    System.out.println("Overview of weekly salary:");
    for (Employee emp : empArray){
      empSalary = emp.calculateSalary(Employee.NORMAL_WORKWEEK);
      System.out.println("The employee " + emp.firstName + " " +
        emp.lastName+ " has a weekly salary of " + empSalary + " GBP");
      sumSalaries += empSalary;
    }
    System.out.println("Salary statistics:");
    System.out.println("Total salary costs for " + empArray.length +
      " employees is " + sumSalaries + " GBP");

    // Problem 2:
    // Calculates the total number of managers and the total amount paid out
    // as manager bonuses.
    int numManagers = 0;
    double sumBonuses = 0.0;
    for (Employee emp : empArray){
      if (emp instanceof Manager){
        numManagers++;
        Manager manager = (Manager) emp;
        sumBonuses += manager.managerBonus;
      }
    }
    System.out.println("Total bonuses for " + numManagers +
        " managers is " + sumBonuses + " GBP");
  }
}