/**
 * Calculating employee salaries and other statistics.
 * Employee data is read from the keyboard.
 */
public class SalaryClient2 {
  public static void main(String[] args) {
    // Creates a text user interface for input of data on employees
    TextUserInterface tui = new TextUserInterface();

    // Problem 1:
    // Creates an array that can hold different types of employees:
    int numEmps = tui.requestInteger("Number of employees");
    Employee[] empArray = new Employee[numEmps];

    // Problem 2:
    // Inserts employees into the employee array,
    // reading the data for each employee from the keyboard.
    for (int i=0; i < empArray.length; i++){
      empArray[i] = tui.inputEmployee("employee no." + (i+1));
    }

    // Calculates the weekly salary for each employee.
    // Calculates and prints the total amount paid out in salaries.
    double salary;
    double sumSalaries = 0.0;
    System.out.println("Overview of weekly salary:");
    for (Employee emp : empArray){
      salary = emp.calculateSalary(Employee.NORMAL_WORKWEEK);
      System.out.println("The employee " + emp.firstName + " " +
                         emp.lastName + " has a weekly salary of " +
                         salary + " GBP");
      sumSalaries += salary;
    }
    System.out.println("Salary statistics:");
    System.out.println("Total salary costs for " + empArray.length +
      " employees is " + sumSalaries + " GBP");

    // Calculates the total number of managers and the total amount paid out
    // as manager bonuses.
    int numManagers = 0;
    double sumBonuses = 0.0;
    for (Employee emp : empArray){
      if (emp instanceof Manager){
        numManagers++;
        Manager manager = (Manager) emp;
        sumBonuses += manager.managerBonus;
      }
    }
    System.out.println("Total bonuses for " + numManagers +
      " managers is " + sumBonuses + " GBP");
  }
}