import java.util.Scanner;
/**
 * Uses polymorphism to calculate the weekly salary of any employee.
 */
public class SalaryManager {
  public static void main(String[] args) {

    Scanner keyboard = new Scanner(System.in);

    // Chose which type of employee to create.
    System.out.println("Types of employees:");
    System.out.println(" 1 - Employee");
    System.out.println(" 2 - Hourly worker");
    System.out.println(" 3 - Manager");
    System.out.println(" 4 - Piece worker");
    System.out.print("Choose a category: ");
    int employeeCode = keyboard.nextInt();                              // (1)
    EmployeeV0 employee;                               // superclass reference
    // Creates an employee of the chosen type
    switch (employeeCode) {
    case 1:
      employee = new EmployeeV0("John", "Doe", 30.0);                   // (2)
      break;
    case 2:
      employee = new HourlyWorkerV0("Mary", "Smith", 35.0);             // (3)
      break;
    case 3:
      employee = new ManagerV2("John D.", "Boss", 60.0, 105.0);         // (4)
      break;
    case 4:
      employee = new PieceWorkerV0("Ken", "Jones", 12.5, 75);           // (5)
      break;
    default:
      System.out.println("Invalid category - creates an EmployeeV0");
      employee = new EmployeeV0("Mark", "Spencer", 25.0);               // (6)
      break;
    }

    // Prints the state and weekly salary for the employee
    System.out.println("Employee information:");
    employee.printState();                                              // (7)
    System.out.printf("Weekly salary: %.2f GBP%n",
                      employee.calculateSalary(42.5));                  // (8)
  }
}