class Student implements ISportsClubMember {                         // (1)

  // Field variables
  String firstName;
  String lastName;
  int credits;

  // Constructors
  /**
   * Creates a student with the specified name and credits.
   */
  public Student(String firstName, String lastName, int credits) {
    this.firstName = firstName;
    this.lastName = lastName;
    this.credits = credits;
  }

  /**
   * Prints the name and number of credits for the student.
   */
  void printState() {
    System.out.printf("Student %s %s has %d credits.%n",
                      firstName, lastName, credits);
  }

  // Implements the interface
  /**
   * Calculates the membership fee.
   * @post return >= 0.0
   */
  public double calculateFee() {                                      // (2)
    double fee = 10.0;
    assert fee >= 0.0 : "Membership fee for students must be >= 0.0"; // @post
    return fee;
  }
  // Other members...
}