// File: TestGameBoard.java
public class TestGameBoard {
  public static void main(String[] args) {
    testEmptyCell();
    testDropPiece();
  }

  public static void testEmptyCell() {
    GameBoard board = new GameBoard();
    // Bottom row has index 0.
    int row = 0;
    // The leftmost column also has index 0
    int column = 0;
    assert board.pieceAt(column, row) == GameBoard.EMPTY_CELL;
  }

  public static void testDropPiece() {
    GameBoard board = new GameBoard();
    board.dropPieceDownColumn('X', 0);
    board.dropPieceDownColumn('O', 2);
    /* The bottom rows should now look like this:

       1 | . . . . . . . |
       0 | X . O . . . . |
         -----------------
        /  0 1 2 3 4 5 6  \
    */
    assert board.pieceAt(0, 0) == 'X';
    assert board.pieceAt(1, 0) == GameBoard.EMPTY_CELL;
    assert board.pieceAt(2, 0) == 'O';
    assert board.pieceAt(0, 1) == GameBoard.EMPTY_CELL;
  }
}