// File: GameTextUserInterface.java
public class GameTextUserInterface {
  static String gameBoardRowAsText(GameBoard board, int row) {
    final int NUMBER_OF_COLUMNS = 7;
    String rowText = "|";
    for (int column = 0; column < NUMBER_OF_COLUMNS; ++column) {
      char state = board.pieceAt(column, row);
      if (state == GameBoard.EMPTY_CELL) {
        rowText += ".";
      } else {
        rowText += state;
      }
      rowText += " ";
    }
    return rowText + "|";
  }

  static String gameBoardAsText(GameBoard board) {
    String text = " 0 1 2 3 4 5 6\n";
    final int TOPMOST_ROW = 5;
    for (int row = TOPMOST_ROW; row >= 0; --row)
      text += gameBoardRowAsText(board, row) + "\n";
    return text + "===============\n";
  }

  public void showGameBoard(GameBoard board) {
    System.out.print(gameBoardAsText(board));
  }

  public static void main(String[] args) {
    GameTextUserInterface ui = new GameTextUserInterface();
    String move = "";
    if (args.length > 0)
      move = args[0];
    ui.showGameBoard(GameSimulator.buildGameBoard(move));
  }
}