// File: TestGameTextUserInterface
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.assertFalse;
import org.junit.Test;

public class TestGameTextUserInterface {
  @Test
  public void testEmptyGameBoardAsText() {
    GameBoard board = new GameBoard();
    assertEquals(" 0 1 2 3 4 5 6\n"
        + "|. . . . . . .|\n"
        + "|. . . . . . .|\n"
        + "|. . . . . . .|\n"
        + "|. . . . . . .|\n"
        + "|. . . . . . .|\n"
        + "|. . . . . . .|\n"
        + "===============\n",
        GameTextUserInterface.gameBoardAsText(board));
  }

  @Test
  public void testEndState() {
    GameBoard board = new GameBoard("2334356322454024430302240006556");
    assertEquals(" 0 1 2 3 4 5 6\n"
        + "|X . X O O . .|\n"
        + "|O . O O X . .|\n"
        + "|X . X O O O .|\n"
        + "|X . O X X X X|\n"
        + "|X . X X X O O|\n"
        + "|O . X O O O X|\n"
        + "===============\n",
        GameTextUserInterface.gameBoardAsText(board));
  }
}