package game; // File: game/IPieceIdentity.java
/**
  Interface for an object that identifies a piece as belonging to
  a particular set of pieces. E.g. one object can
  represent yellow pieces, while another object can represent
  blue pieces.  Pieces r and s are assumed to belong to the same set if
  (r == s) is true.  This interface does not concern itself with how
  pieces are presented, but classes that implement this
  interface are free to provide such information.
 */
public interface IPieceIdentity { }