package game;    // File: game/RandomPlayer.java

public class RandomPlayer implements IPlayer {
  public void performMove(IPieceIdentity piece, GameBoard board) {
    assert !board.isGameOver();

    int choice;
    do {
      choice = (int) (Math.random() * GameBoard.COLUMN_COUNT);
    } while (!board.isValidColumnSelection(choice));

    board.dropPieceDownColumn(piece, choice);
  }
}