package game.swing; // File: game/swing/ComponentColorIdentity.java

import game.IPlayer;
import game.ParticipantIdentity;

import java.awt.Color;
import java.awt.Component;

/**
 * The identity of a participant in a game that is played in a graphical
 * user interface where each cell of the game board is presented
 * as a java.awt.Component with a given colour.
 **/
public class ComponentColorIdentity extends ParticipantIdentity {
  Color color;

  public ComponentColorIdentity(IPlayer player, Color color,
                                String descriptiveName) {
    super(player, descriptiveName);
    this.color = color;
  }

  public void applyComponentColor(Component component) {
    component.setBackground(color);
  }
}