package game.swing;    // File: game/swing/SwingPlayer.java
import game.GameBoard;
import game.IPieceIdentity;
import game.IPlayer;

public class SwingPlayer implements IPlayer {
  GameSwingUI ui;

  SwingPlayer(GameSwingUI ui) {
    this.ui = ui;
  }

  public void performMove(IPieceIdentity piece, GameBoard board) {
    assert !board.isGameOver();
    for (int column = 0; column < GameBoard.COLUMN_COUNT; ++column) {
      ui.setDropPermissionForColumn(column,
                                    board.isValidColumnSelection(column));
    }
  }
}