package game.terminal;    // File: game/terminal/EasyGame.java
import game.GameBoard;
import game.IPieceIdentity;
import game.ParticipantIdentity;
import game.RandomPlayer;
/** An easy game in which the user plays against a computer
    adversary that chooses moves at random. */
public class EasyGame {
  public static void main(String args[]) {
    GameTextUserInterface ui = new GameTextUserInterface();
    IPieceIdentity[] participants = new IPieceIdentity[] {
      new ParticipantIdentity(new TerminalPlayer(), "T"),
      new ParticipantIdentity(new RandomPlayer(),   "R")
    };
    IPieceIdentity emptyCell = new ParticipantIdentity(null, ".");
    GameBoard board = new GameBoard(participants, emptyCell, ui);
    ui.runGameLoop();
  }
}