
public class GenericTypes {

  public static void main(String[] args) {
    Pair<String> strPair = new Pair<String>("Adam", "Eve");     // (1)
//  Pair<String> wrongPair = new Pair<String>("17. May", 1905); // (2) Compile-time error!
    Pair<Integer> intPair = new Pair<Integer>(2005, 2010);      // (3)
//  strPair = intPair;                              // (4) Compile-time error!
    Pair<String> tempPair = strPair;                // (5) OK

    Pair<Integer> pair1 = new Pair<Integer>(2005, 2006);
//  Pair<Number> pair3 = pair1;                     // (1) Compile-time error!

    Integer iRef = pair1.getFirst();
    Pair<? extends Number> pair4 = pair1;           // Ok.

    Pair<Double> doublePair = new Pair<Double>(100.50, 200.50);
    double newSum = sumPair(doublePair);        // (2) Ok
//  Pair<Number> numPair = doublePair;          // (3) Compile-time error!
    Pair<? extends Number> newPair = doublePair;// (4) Ok

    Pair<Number> numPair = new Pair<Number>(100.0, 200);
    Pair<Integer> iPair = new Pair<Integer>(100, 200);
    Pair<? super Integer> supPair = numPair;        // (5) Ok
    supPair  = iPair;                               // (6) Ok
    supPair  = doublePair;                          // (7) Compile-time error!

    Pair<?> pairB = numPair;                        // (8) Ok
    pairB = newPair;                                // (9) Ok
    pairB = supPair;                                // (10) Ok
    pairB = new Pair<?>(100.0, 200);                // (11) Compile-time error!
    pairB = new Pair<? extends Number>(100.0, 200); // (12) Compile-time error!
  }

  public static double sumPair(Pair<? extends Number> Pair) {
    return Pair.getFirst().doubleValue() + Pair.getSecond().doubleValue();
  }
}
