import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class MapClient {

  public static void main(String args[]) {
    // (1) Create an empty map for <String, Integer> entries,
    //     representing a word and its frequency.
    Map<String, Integer> wordMap = new HashMap<String, Integer>();

    // (2) Read words from the command line.
    for (int i = 0; i < args.length; i++) {
      // Look up if the word is already registered.
      Integer numOfTimes = wordMap.get(args[i]);
      if (numOfTimes == null)
        numOfTimes = 1;    // Not registered before, i.e. first time.
      else                 // Registered. Frequency is incremented.
        numOfTimes++;
      wordMap.put(args[i], numOfTimes);
    }

    // (3) Print the word map.
    System.out.println("Whole word map: " + wordMap);

    // (4) Print total number of words read.
    Collection<Integer> freqCollection = wordMap.values();
    int totalNumOfWords = 0;
    for (int frequency : freqCollection)
      totalNumOfWords += frequency;
    System.out.println("Total number of words read: " + totalNumOfWords);

    // (5) Print all distinct words.
    Set<String> setOfAllWords = wordMap.keySet();
    System.out.println("All distinct words: " + setOfAllWords);
    System.out.println("Number of distinct words: " + wordMap.size());

    // (6) Print all duplicated words.
    Collection<String> setOfDuplicatedWords = new HashSet<String>();
    for (String key : setOfAllWords) {
      int numOfTimes = wordMap.get(key);
      if (numOfTimes != 1)
        setOfDuplicatedWords.add(key);
    }
    System.out.println("All duplicated words: " + setOfDuplicatedWords);
    System.out.println("Number of duplicated words: " +
                       setOfDuplicatedWords.size());
  }
}