/**
 * The Point3D class represents a point in space,
 * and it overrides both the equals() method and the hashCode() method.
 */
class Point3D {                                                 // (2)
  int x;
  int y;
  int z;

  Point3D(int x, int y, int z) {
    this.x = x;
    this.y = y;
    this.z = z;
  }

  public String toString() { return "["+x+","+y+","+z+"]"; }

  /** Two points are equal if they have the same x, y and z coordinates. */
  public boolean equals(Object obj) {                           // (3)
    if (this == obj) return true;
    if (!(obj instanceof Point3D)) return false;
    Point3D p2 = (Point3D) obj;
    return this.x == p2.x && this.y == p2.y && this.z == p2.z;
  }

  /** The hash value is computed based on the coordinate values. */
  public int hashCode() {                                       // (4)
    int hashValue = 11;
    hashValue = 31 * hashValue + x;
    hashValue = 31 * hashValue + y;
    hashValue = 31 * hashValue + z;
    return hashValue;
  }
}