import java.util.HashSet;
import java.util.Set;

public class SetClient {
  public static void main(String args[]) {
    // (1) Create two sets for concerts:
    Set<String> concertA = new HashSet<String>();
    Set<String> concertB = new HashSet<String>();
    System.out.println("(1) Created an empty concert A: " + concertA);
    System.out.println("(1) Created an empty concert B: " + concertB);

    // (2) Add artists to the concerts:
    concertA.add("aha"); concertA.add("madonna");
    concertA.add("abba"); concertA.add("kiss");
    concertA.add("Sivle");
    System.out.println("(2) Artists in concert A: " + concertA);

    concertB.add("TLC"); concertB.add("madonna");
    concertB.add("abba"); concertB.add("wham");
    System.out.println("(2) Artists in concert B: " + concertB);

    // (3) Duplicates are not allowed in sets:
    String artist = "TLC";
    if (concertB.add(artist))
      System.out.println("(3) Artist " + artist +
                         " registered for concert B.");
    else
      System.out.println("(3) Artist " + artist +
                         " already registered for concert B.");

    // (4) Subset: determine whether all artists that performed
    //     in concert B also performed in concert A:
    if (concertA.containsAll(concertB))
      System.out.println("(4) All artists in concert B performed" +
                         " in concert A.");
    else
      System.out.println("(4) Not all artists in concert B performed" +
                         " in concert A.");

    // (5) Union: find all artists:
    Set<String> allArtists = new HashSet<String>(concertA);
    allArtists.addAll(concertB);
    System.out.println("(5) All artists: " + allArtists);

    // (6) Intersection: find artists that performed in both concerts:
    Set<String> bothConcerts = new HashSet<String>(concertA);
    bothConcerts.retainAll(concertB);
    System.out.println("(6) Artists that performed in both concerts: " +
                       bothConcerts);

    // (7) Difference: find artists that performed in concert A only:
    Set<String> onlyConcertA = new HashSet<String>(concertA);
    onlyConcertA.removeAll(concertB);
    System.out.println("(7) Artists that performed in concert A only: " +
                       onlyConcertA);

    // (8) Difference: find artists that performed in concert B only:
    Set<String> onlyConcertB = new HashSet<String>(concertB);
    onlyConcertB.removeAll(concertA);
    System.out.println("(8) Artists that performed in concert B only: " +
                       onlyConcertB);
  }
}