
public class StringBuilderClient {
  public static void main(String[] args) {

// Create some string builders
StringBuilder buffer1 = new StringBuilder();     // length 0, capacity 16
StringBuilder buffer2 = new StringBuilder(20);   // length 0, capacity 20

// String builder of length 4, capacity 21, character sequence "mama":
StringBuilder buffer3 = new StringBuilder("mama");
String str1 = new String("mia");
//String builder of length 3, capacity 19, character sequence "mia"
StringBuilder buffer4 = new StringBuilder(str1);
System.out.println("buffer1: " + buffer1);
System.out.println("buffer2: " + buffer2);
System.out.println("buffer3: " + buffer3);
System.out.println("buffer4: " + buffer4);

// Capacity and length of a string builder.
int capacity = buffer4.capacity();   // 19
int length = buffer4.length();       // 3
System.out.println("Capacity of buffer4: " + capacity);
System.out.println("Length of buffer4: " + length);

// Conversion to string and string comparison.
String str2 = buffer3.toString();                              // "mama"
boolean flag = buffer3.toString().equals(buffer4.toString());  // false
System.out.println("Comparison result: " + flag);

// Looking up, modifying and deleting characters.
char ch = buffer4.charAt(1);    // 'i'
buffer4.setCharAt(0,'P');       // "Pia"
buffer4.deleteCharAt(2);        // "Pi"
System.out.println("buffer4 after modification: " + buffer4);

// Append to the string builder.
buffer3.append(" mia ");        // "mama mia "
buffer3.append('R');            // "mama mia R"
buffer3.append(4);              // "mama mia R4"
buffer3.append('U');            // "mama mia R4U"
buffer3.append(new Integer(2)); // "mama mia R4U2"
System.out.println("buffer3 after appending: " + buffer3);

// Inserting into a string builder.
buffer1.insert( 0, "Saturday");      // "Saturday"
buffer1.insert( 8, "  March ");      // "Saturday  March "
buffer1.insert( 9, 1);               // "Saturday 1 March "
buffer1.insert(buffer1.length(),
               new Integer(2008));   // "Saturday 1 March 2008"
buffer1.insert( 10, '.');            // "Saturday 1. March 2008"
System.out.println("buffer1 after insertion: " + buffer1);

// String concatenation
String name1 = "seven" + 11;          // "seven11"
String name2 = new StringBuilder().append("seven").append(11).toString();
System.out.println("String concatenation: " + name1);
System.out.println("String concatenation using string builder: " + name2);
  }
}
