import java.util.Iterator;
/**
 * NB! THIS CLASS IMPLEMENTATION IS NOT COMPLETE!!
 * This class implements double linked lists.
 */
public class DoubleLinkedList<E> implements IDoubleLinkedList<E> {

  // Fields
  /** Reference to the first node in the list. */
  private BiNode<E> head;

  /** Reference to the last node in the list. */
  private BiNode<E> tail;

  /** Number of nodes in the list. */
  private int numOfNodes;

  // Mutators
  /**
   * Inserts a node at the head of the list.
   * @param data_obj Data stored in the node.
   */
  public void insertAtHead(E data_obj) {                        // (1)
    BiNode<E> p = new BiNode<E>(data_obj, null, null);
    if (isEmpty())
      head = tail = p;
    else { // head = new BiNode(data_obj, head);
      p.setNext(head);   // Step 1
      head = p;          // Step 2
    }
    numOfNodes++;
  }

  /**
   * Insert a node at the tail of the list.
   * @param data_obj Data to stored in the node.
   */
  public void insertAtTail(E data_obj) {                        // (2)
    BiNode<E> p = new BiNode<E>(data_obj, null, null);
    if (isEmpty())
      head = tail = p;
    else {
      tail.setNext(p);   // Step 1
      tail = p;          // Step 2
    }
    numOfNodes++;
  }

  /**
   * Removes the first node in the list.
   * Assumes that the list is not empty.
   * @return Data in noden that is removed.
   */
  public E removeFromHead() {                                   // (3)
    assert numOfNodes > 0 : "List cannot be empty.";
    BiNode<E> p = head;       // Step 1
    if (head == tail)
      head = tail = null;     // Only one node in the list
    else
      head = p.getNext();     // Step 2
    numOfNodes--;
    return p.getData();
  }

  /**
   * Removes the last node in the list.
   * Assumes that the list is not empty.
   * @return Data in noden that is removed.
   */
  public E removeFromTail() {                                   // (4)
    assert numOfNodes > 0 : "List cannot be empty.";
    BiNode<E> p = tail;            // Step 1
    if (head == tail)
      head = tail = null;          // Only one node in the list
    else {
      BiNode<E> nextToLast = head; // Step 2
      while (nextToLast.getNext() != tail)
        nextToLast = nextToLast.getNext();

      tail = nextToLast;           // Step 3
      tail.setNext(null);          // Step 4
    }
    numOfNodes--;
    return p.getData();
  }

  /**
   *
   * Removes node with the specified data from the list.
   * @param data_obj Data in the node to be removed.
   * @return True, if a node with the specified data is removed.
   */
  public boolean remove(E data_obj) {                           // (5)
    // Traverse through the list.
    BiNode<E> currentNode = head;
    BiNode<E> predessesor = null;
    boolean found = false;
    while (currentNode != null && !found) {
      if (currentNode.getData().equals(data_obj)) {
        found = true;
      } else {
        // Not found yet. Update predessesor and current node.
        predessesor = currentNode;
        currentNode = currentNode.getNext();
      }
    }
    if (found) {
      if (predessesor == null) {
        // Found in the first node of the list.
        removeFromHead(); // Bruker slettForan()-metoden
      } else if (currentNode.getNext() == null) {
        // Found in the last node of the list.
        tail = predessesor;
        tail.setNext(null);
        numOfNodes--;
      } else {
        // Found in a node inside the list.
        predessesor.setNext(currentNode.getNext());
        numOfNodes--;
      }
    }
    return found;
  }

  // Selectors
  /**
   * Determines whether the list is empty.
   * @return True, if the list is empty, otherwise false.
   */
  public boolean isEmpty() { return head == null; }

  /**
   * Returns the number of nodes in the list.
   * @return Number of nodes in the list.
   */
  public int numOfNodes() { return numOfNodes; }

  /**
   * Returns the first node in the list.
   * @return The first node in the list.
   */
  public BiNode<E> first() { return head; }

  /**
   * Returns the last node in the list.
   * @return The last node in the list.
   */
  public BiNode<E> last() { return tail; }

  /**
   * Find node with the given data.
   * @param data_obj Data in the noden to be found.
   * @return BiNode with the given data, otherwise null.
   */
  public BiNode<E> find(E data_obj) {
    // Traverse the list
    BiNode<E> currentNode = head;
    while (currentNode != null) {
      if (currentNode.getData().equals(data_obj))
        return currentNode;     // Found.
      currentNode = currentNode.getNext();
    }
    return null;                // Not found.
  }

  // Other useful methods
  /**
   * Return an iterator for the list.
   * @return The Iterator
   */
  public Iterator<E> iterator() {                               // (6)
    return new DoubleLinkedListIterator<E>(this);
  }

  /** Fill the specified array with data from the nodes in the list. */
  public void listToArray(E[] array) {                          // (7)
    assert array.length == numOfNodes : "Array not right size.";
    int i = 0;
    for (E data : this)
      array[i++] = data;
  }
}