import java.util.ArrayList;
import java.util.List;

public class ListToArrayDemo {

  public static void main(String[] args) {
    LinkedList<Character> lst = new LinkedList<Character>();
    lst.insertAtHead('a');
    lst.insertAtHead('b');
    lst.insertAtHead('b');
    lst.insertAtHead('a');

    for (char c : lst)
      System.out.print(c); // (2)
    System.out.println();

    Character[] array = new Character[lst.numberOfNodes()];
    lst.listToArray(array);
    System.out.println(array.length);
    for (int i = 0; i < array.length; i++)
      System.out.print(array[i]);            // (1)
    System.out.println();

    for (int i = 0; i < array.length; i++)
      System.out.print(array[i]); // (2)
    System.out.println();

    List<Character> myList = arrayToList(array);
    for (char c : lst)
      System.out.print(c); // (2)
    System.out.println();
  }

  public static <T> List<T> arrayToList(T[] array) {
    List<T> list = new ArrayList<T>();
    for (T data : array)
      list.add(data);
    return list;
  }

  public static List arrayToListV1(Object[] array) {
    List<Object> list = new ArrayList<Object>();
    for (Object data : array)
      list.add(data);
    return list;
  }

  public static List arrayToListV2(Object[] array) {
    List list = new ArrayList();
    for (Object data : array)
      list.add(data);
    return list;
  }

  public static List arrayToListV3(Object[] array) {
    List<String> list = new ArrayList<String>();
    for (String data : (String[]) array)
      list.add(data);
    return list;
  }
}