import java.util.Scanner;

// Recursive binary search for prime numbers.
public class FindRecursively {
  // Constant that signals that a number does not exist in the array.
  static final int NOT_THERE = -1;

  public static void main(String[] args) {
    // Array containing prime numbers between 1 and 100 in ascending order:
    int[] primeNumbers = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47,
        53, 59, 61, 67, 71, 73, 79, 83, 89, 97};

    System.out.print("Type an integer between 1 and 100: ");
    Scanner keyboard = new Scanner(System.in);
    int number = keyboard.nextInt();
    if ((number < 1) || (number > 100)) {
      System.out.println("The number is not between 1 and 100: " + number);
      return ;
    }

    int primeNumberIndex = find(primeNumbers, number);
    if (primeNumberIndex == NOT_THERE) {
      System.out.println(number + " is not a prime number.");
    } else {
      System.out.println(number + " is a prime with position "
          + (primeNumberIndex + 1) + " in the sequence of prime numbers.");
    }
  }

  static int find(int[] sortedArray, int key) {
    return binarySearch(sortedArray, key, 0, sortedArray.length - 1);
  }

  static int binarySearch(int[] sortedArray, int key, int lower, int upper) {
    if (lower > upper) {
      /* base case, the parameters specify an empty array segment,
         i.e. the key does not exist in the array. */
      return NOT_THERE;
    }

    int middle = (lower + upper) / 2;
    int middleNumber = sortedArray[middle];

    if (key == middleNumber) {
      return middle;  // Another base case. The key was found.
    }

    // General case: search in either lower or upper array segment.
    if (key < middleNumber) {
      return binarySearch(sortedArray, key, lower, middle - 1);
    } else {
      return binarySearch(sortedArray, key, middle + 1, upper);
    }
  }
}
