// Towers of Hanoi - Recursive version.
public class Hanoi {
  public static void main(String[] args) {

    int numRings = 4;

    System.out.println("Moving " + numRings + " rings:");
    /* Move all rings from peg 1 to peg 3 by using peg 2 as
       temporary storage. */
    moveRings(numRings, 1, 3, 2);
  }

  static void moveRings(int count, int from, int to, int tmp) {
    if (count < 1) {
      // Base case: No rings to move.
      return ;
    }

    /* To move the bottom ring, we first have to move the count-1
       rings on top of this ring away from the current peg. Let this
       subtask use the "to" peg as temporary storage: */
    moveRings(count - 1, from, tmp, to);

    // The bottom ring can now be moved:
    System.out.println(from + " ---> " + to);

    /* The topmost count-1 rings on the "tmp" peg can now be moved to
       the "to" peg. Let this subtask use the now vacant "from" peg
       as temporary storage: */
    moveRings(count - 1, tmp, to, from);
  }
}