// Iterative Fibonacci calculation.
public class IterativeFibonacciTimed {
  public static void main(String[] args) {
    long startTime = System.nanoTime();                                   // (1)
    System.out.println("The 45th number in the Fibonacci sequence is " +
                       fibonacci(45));            // The code to be timed.
    System.out.println("Execution time: " +
                       (System.nanoTime()-startTime) + "ns");             // (2)
  }

  static int fibonacci(int n) {
    int nextToLast = 1;
    int last = 1;
    for (int i = 3; i <= n; i++) {
      // Calculate a new Fibonacci number.
      int next = last + nextToLast;

      // Store the last two Fibonacci numbers in the series so far:
      nextToLast = last;
      last = next;
    }
    return last;
  }
}