import java.io.IOException;
/*
 * Company administration using text files.
 */
public class CompanyAdmin {

  public static void main(String[] args) throws IOException {      // (1)
    // Create an array of employees.
    Employee[] employeeInfo = {
        new Employee("Ole",  "Olsen",  30.00, Gender.MALE),
        new Employee("Bill", "Bailey", 40.00, Gender.MALE),
        new Employee("Liv",  "Larsen", 50.00, Gender.FEMALE)
    };

    // Create a personnel register.
    PersonnelRegister register = new PersonnelRegister(employeeInfo);

    // Create a company.
    CompanyUsingTextFiles company = new CompanyUsingTextFiles(register);

    // Print employee data in personnel register to a text file.
    company.writeAllEmployeesToTextFile("employeeFile.txt");       // (2)

    // Read employee data from a text file.
    System.out.println("Read from text file.");
    company.readAllEmployeesFromTextFile("employeeFile.txt");      // (3)

    // Print employee data to the terminal window.
    company.printAllEmployeesToTerminalWindow();
    company.printReport();
  }
}