import java.util.Scanner;

/**
 * Class that reads employee data from the terminal
 * window and prints some statistics.
 */
class CompanyUsingTerminalWindow {

  // Field
  private PersonnelRegister register;

  // Constructors
  public CompanyUsingTerminalWindow() {
    register = new PersonnelRegister();
  }
  public CompanyUsingTerminalWindow(PersonnelRegister register) {
    this.register = register;
  }

  // Write statistics.
  void printReport() {
    System.out.println(register);
  }
  void writeAllEmployeesToTerminalWindow() {
    Employee[] employees = register.getEmployeeArray();
    int numOfEmployees = register.getNumOfEmployees();
    System.out.println("No. of employees: " + numOfEmployees);
    for (int i = 0; i < numOfEmployees; i++)
      System.out.println(employees[i]);
  }

  void readAllEmployeesFromTerminalWindow() {                    // (1)
    Scanner keyboard = new Scanner(System.in);
    String reply = null;
    do {
      System.out.println("Specify data for an employee.");
      System.out.print("First name: ");
      String firstName = keyboard.nextLine();
      System.out.print("Last name: ");
      String lastName = keyboard.nextLine();
      System.out.print("Hourly rate: ");
      double hourlyRate = keyboard.nextDouble();
      keyboard.nextLine();
      System.out.print("Is it a woman? (y/n): ");
      reply = keyboard.nextLine();
      Gender gender = Gender.MALE;
      if (reply.equals("y"))
        gender = Gender.FEMALE;
      Employee employee = new Employee(firstName, lastName,
                                       hourlyRate, gender);
      register.registerEmployee(employee);
      System.out.print("Register more employees? (y/n): ");
      reply = keyboard.nextLine();
    } while (reply.equals("y"));
  }

  public static void main(String[] args) {
    // Create a personnel register.
    PersonnelRegister register = new PersonnelRegister();
    // Create a company.
    CompanyUsingTerminalWindow company
                            = new CompanyUsingTerminalWindow(register);

    // Read employee data from terminal window.
    System.out.println("Reading from terminal window.");
    company.readAllEmployeesFromTerminalWindow();

    // Print statistics to terminal window.
    company.writeAllEmployeesToTerminalWindow();
    company.printReport();
  }

}