//Copy one file to another.
import java.io.*;

class CopyFile {

  public static void main(String args[]) {
    int i;
    FileInputStream srcFile;
    FileOutputStream dstFile;
    try { // Read file names from the command line.
      srcFile = new FileInputStream(args[0]);
      dstFile = new FileOutputStream(args[1]);
    } catch(FileNotFoundException e) {
      System.out.println("File not found");
      return;
    } catch(IOException e) {
      System.out.println("File cannot be opened.");
      return;
    } catch(ArrayIndexOutOfBoundsException e) {
      System.out.println("Usage: CopyFile <source file> <destination file>");
      return;
    }
    // Copying
    try {
      i = srcFile.read();
      while (i != -1) { // eof?
        dstFile.write(i);
        i = srcFile.read();
      }
    } catch(IOException e) {
      System.out.println("File I/O error.");
    }

    // Close files.
    try {
      srcFile.close();
      dstFile.close();
    } catch (IOException e) {
      System.out.println("Error on closing.");
    }
  }
}
