/*
 * Lists all files under a (given) directory
 */
import java.io.*;

public class DirectoryListing {
  public static void listDirectory(File file) {
    try {
      if (!file.exists()) {
        System.out.println(file.getCanonicalPath() + " not found.");
      } else if (file.isFile()) {
        System.out.println(file.getCanonicalPath());
      } else { // Directory
        String[] fileName = file.list();
        for (int i = 0; i < fileName.length; i++) {
          File tf = new File(file.getPath(), fileName[i]);
          listDirectory(tf);
        }
      }
    }
    catch (IOException e) { System.out.println("Error: " + e); }
  }

  public static void main(String args[]) {
    File file = null;
    if (args.length == 0)
      file = new File("..");  // Use parent directory
    else
      file = new File(args[0]);
    listDirectory(file);
  }
}
