final class PieceWorker extends Employee {

  // New fields
  private double pricePerUnit;
  private int numOfUnits;

  // Constructors
  public PieceWorker() { /* Default values of fields. */ }
  public PieceWorker(String firstName, String lastName, Gender gender,
                        double pricePerUnit, int numOfUnits) {
    super(firstName, lastName, 0.0, gender);
    this.pricePerUnit = pricePerUnit;
    this.numOfUnits = numOfUnits;
  }

  public String toString() {
    return super.toString()
         + "\nis paid " + String.format("%.2f", pricePerUnit) +
         " per unit, and has made " + numOfUnits + " units.";
  }

  // Overrides method in the superclass Employee
  public double computeSalary(double numOfHours) { // Ignores parameter.
    return computeSalary();
  }

  // New instance methods
  public double computeSalary() { return numOfUnits * pricePerUnit; }

  public void setPricePerUnit(double unitprice) {
    pricePerUnit = unitprice;
  }

  public double getPricePerUnit() { return pricePerUnit; }

  public void setNumOfUnits(int numOfUnits) {
    this.numOfUnits = numOfUnits;
  }

  public int getNumOfUnits() { return numOfUnits; }
}