import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

public class SerialisingWithoutDuplication {

  public static void main(String[] args) {

    // (1) Create a number of objects:
    StringBuilder advice0 = new StringBuilder("Speak no evil");
    StringBuilder[] array0 = {
        advice0,                             // (2) Common advice.
        new StringBuilder("Hear no evil"),
        new StringBuilder("See no evil")
    };

    String fileName = "advice.data";

    try {
      // Create streams for serialisation.                           (3)
      FileOutputStream outFile = new FileOutputStream(fileName, false);
      ObjectOutputStream outStream = new ObjectOutputStream(outFile);

      // Write array0 and advice0 twice.                             (4)
      outStream.writeObject(array0);
      outStream.writeObject(advice0);
      outStream.writeObject(array0);
      outStream.writeObject(advice0);

      outStream.close();

      // Create streams for serialisation.                           (5)
      FileInputStream   inFile = new FileInputStream(fileName);
      ObjectInputStream inStream = new ObjectInputStream(inFile);

      // Read serialised objects in the right order.                 (6)
      StringBuilder array1[] = (StringBuilder[])inStream.readObject();
      StringBuilder advice1 = (StringBuilder)inStream.readObject();
      StringBuilder array2[] = (StringBuilder[])inStream.readObject();
      StringBuilder advice2 = (StringBuilder)inStream.readObject();

      // Test if two references are equal,i.e. if they refer
      // to the same object.                                         (7)
      System.out.println("array0 and array1 refer to same object: "
          + (array0 == array1));
      System.out.println("advice0 and array1[0] refer to same object: "
          + (advice0 == array1[0]));
      System.out.println("array1 and array2 refer to the same object: "
          + (array1 == array2));
      System.out.println("advice1 and advice2 refer to the same object: "
          + (advice1 == advice2));
      System.out.println(
          "array1[0] and array2[0] refer to the same object: "
          + (array1[0] == array2[0]));
      System.out.println(
          "array1[0] and advice2 refer to the same object: "
          + (array1[0] == advice2));

      // Test if two objects are equal.                              (8)
      System.out.println(
          "Objects referenced by advice0 and array1[0] " +
          "have the same state: " +
          advice0.toString().equals(array1[0].toString()));

      inStream.close();
    }
    catch (IOException exception) {
      System.out.print("Error on file I/O: " + exception);
      System.exit(1);
    }
    catch (ClassNotFoundException exception) {
      System.out.print("Class definition not found: " + exception);
      System.exit(1);
    }
  }
}