import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

class BorderLayoutDemo extends JFrame {

  // Components
  private JButton drawButton;
  private JButton zoomInButton;
  private JButton zoomOutButton;
  private JLabel banner;
  private JTextField messageField;

  BorderLayoutDemo() {
    // Set suitable title for the frame.
    super("BorderLayoutDemo");

    // Create 3 buttons.
    drawButton = new JButton("Draw");
    zoomInButton = new JButton("Zoom in");
    zoomOutButton = new JButton("Zoom out");

    // Create a label.
    banner = new JLabel("Win a tour to Java!", SwingConstants.CENTER);
    banner.setForeground(Color.blue);

    // Create a text field.
    messageField = new JTextField("MESSAGES");
    messageField.setEditable(false);
    messageField.setBackground(Color.white);

    // Get the content pane of the frame.
    Container contentPane = getContentPane();

    // Create and set a Borderlayout manager.
    contentPane.setLayout(new BorderLayout());

    // Construct the component hierarchy.
    contentPane.add(drawButton, BorderLayout.NORTH);
    contentPane.add(zoomInButton, BorderLayout.WEST);
    contentPane.add(zoomOutButton, BorderLayout.EAST);
    contentPane.add(banner, BorderLayout.CENTER);
    contentPane.add(messageField, BorderLayout.SOUTH);

    // Terminate if the frame is closed.
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    // Show the GUI.
    pack();
    setVisible(true);
  }
}