import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JTextField;

class EchoWithDialog extends JFrame implements ActionListener {

  // Components.
  private JButton integerButton;
  private JTextField integerField;
  private IntegerDialogWindow integerDialog;

  EchoWithDialog() {
    // Set suitable title for the frame.
    super("Echo with Dialog");

    // Create GUI components.
    integerField = new JTextField(10);
    integerField.setEditable(false);
    integerButton = new JButton("Type an integer ...");

    // Set up the GUI.
    Container contentPane = getContentPane();
    contentPane.setLayout(new FlowLayout());
    contentPane.add(integerField);
    contentPane.add(integerButton);

    // Register the frame as listener with the button
    // to receive ActionEvents.
    integerButton.addActionListener(this);

    // Terminate if the frame is closed.
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    // Show the GUI.
    pack();
    setVisible(true);
  }

  // Show the integer in the text field.                                 (1)
  public void showInteger(String str) {
    integerField.setText(str);
  }

  // Called when the user clicks the "Type an integer ..." button.       (2)
  public void actionPerformed(ActionEvent e) {
    integerDialog = new IntegerDialogWindow(this);
  }
}
