import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

class EchoWithEvents extends JFrame implements ActionListener {    // (1)

  // Components
  private JPanel panel1, panel2, panel3;
  private JButton doneButton;
  private JLabel inputLabel;
  private JLabel echoLabel;
  private JTextField inputField;
  private JTextField echoField;

  EchoWithEvents() {
    // Set suitable title for the frame.
    super("Echo Input (Event handling)");

    // Create GUI components.
    panel1 = new JPanel();
    panel1.setBackground(Color.yellow);
    panel2 = new JPanel();
    panel2.setBackground(Color.pink);
    panel3 = new JPanel();
    panel3.setBackground(Color.cyan);

    doneButton = new JButton("Done");

    inputLabel = new JLabel("Input field:");
    echoLabel = new JLabel("Echo field:");

    inputField = new JTextField("Type here. " + "End with Enter key.", 10);
    inputField.setEditable(true);

    echoField = new JTextField("", 10);
    echoField.setEditable(false);
    echoField.setBackground(Color.lightGray);

    // Get the content pane for the frame.
    Container contentPane = getContentPane();
    contentPane.setBackground(Color.white);

    // Set a layout manager for the content pane.
    contentPane.setLayout(new GridLayout(3, 1));

    // Construct the component hierarchy.
    panel1.add(inputLabel);
    panel1.add(inputField);
    panel2.add(echoLabel);
    panel2.add(echoField);
    panel3.add(doneButton);
    contentPane.add(panel1, BorderLayout.NORTH);
    contentPane.add(panel2, BorderLayout.CENTER);
    contentPane.add(panel3, BorderLayout.SOUTH);

    // Register the frame as listener with the text field
    // to receive ActionEvents.
    inputField.addActionListener(this);                            // (2)

    // Register the frame as listener with the Done button
    // to receive ActionEvents.
    doneButton.addActionListener(this);                            // (3)

    // Terminate if the frame is closed.
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    // Show the GUI.
    pack();
    setVisible(true);
  }

  public void actionPerformed(ActionEvent event) {                 // (4)
    if (event.getSource() == inputField) {
      String inputString = inputField.getText();
      echoField.setText(inputString);
    } else { // the source was the Done button.
      System.out.println("Done.");
      dispose();
      System.exit(0);
    }
  }
}