import java.awt.Color;
import java.awt.Container;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

class EchoWithGUIOnly extends JFrame {

  // Components
  private JPanel panel1, panel2;
  private JButton doneButton;
  private JLabel inputLabel;
  private JLabel echoLabel;
  private JTextField inputField;
  private JTextField echoField;

  EchoWithGUIOnly() {
    // Set suitable title for the frame.
    super("Echo Input");

    // Create GUI components.
    panel1 = new JPanel();
    panel1.setBackground(Color.yellow);
    panel2 = new JPanel();
    panel2.setBackground(Color.pink);

    doneButton = new JButton("Done");
    doneButton.setBackground(Color.cyan);

    inputLabel = new JLabel("Input field:");
    echoLabel = new JLabel("Echo field:");

    inputField = new JTextField("Type here." + "End with Enter key.", 10);
    inputField.setEditable(true);

    echoField = new JTextField("", 10);
    echoField.setEditable(false);
    echoField.setBackground(Color.lightGray);

    // Get the content pane for the frame.
    Container contentPane = getContentPane();
    contentPane.setBackground(Color.white);

    // Set layout manager for the content pane.
    contentPane.setLayout(new FlowLayout());

    // Construct the component hierarchy.
    panel1.add(inputLabel);
    panel1.add(inputField);
    panel2.add(echoLabel);
    panel2.add(echoField);
    contentPane.add(panel1);
    contentPane.add(panel2);
    contentPane.add(doneButton);

    // Terminate if the frame is closed.
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    // Show the GUI.
    pack();
    setVisible(true);
  }
}