import java.awt.Container;      // (1) Classes from the awt package
import java.awt.FlowLayout;
import java.awt.Color;

import javax.swing.JFrame;      // (2) Classes from the swing package
import javax.swing.JLabel;

class GUIFrame extends JFrame { // (3)

  // (4) Components
  private JLabel label1;
  private JLabel label2;

  GUIFrame() { // (5)
    // (6) Set suitable title for the frame.
    super("Top-level window");

    // (7) Create components.
    label1 = new JLabel("Tax Return for the year 2008");
    label1.setForeground(Color.black);
    label2 = new JLabel("Full disclosure");
    label2.setForeground(Color.black);

    // (8) Get the content pane for the frame.
    Container contentPane = getContentPane();

    // (9) Set layout manager for the content pane.
    contentPane.setLayout(new FlowLayout());

    // (10) Construct the component hierarchy.
    contentPane.add(label1);
    contentPane.add(label2);

    // (11) Terminate if the frame is closed.
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    // (12) Show the GUI.
    pack();
    setVisible(true);
  }
}