import java.awt.Color;
import java.awt.Container;
import java.awt.GridLayout;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;

class GridLayoutDemo extends JFrame {

  // Components
  private JLabel xJLabel;
  private JLabel yJLabel;
  private JTextField xInput;
  private JTextField yInput;

  GridLayoutDemo() {
    // Set a suitable title for the frame.
    super("GridLayoutDemo");

    // Create two labels and two text fields.
    xJLabel = new JLabel("X coordinate:");
    yJLabel = new JLabel("Y coordinate:");
    xInput = new JTextField(5);
    yInput = new JTextField(5);
    xInput.setBackground(Color.yellow);
    yInput.setBackground(Color.yellow);

    // Get the content pane for the frame.
    Container contentPane = getContentPane();

    // Create and set a GridLayout with a 2x2 grid.
    contentPane.setLayout(new GridLayout(2, 2));

    // Construct the component hierarchy.
    contentPane.add(xJLabel); // [0,0]
    contentPane.add(xInput);  // [0,1]
    contentPane.add(yJLabel); // [1,0]
    contentPane.add(yInput);  // [1,1]

    // Terminate if the frame is closed.
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    // Show the GUI.
    pack();
    setVisible(true);
  }
}