import java.awt.Color;
import java.awt.Container;
import java.awt.GridLayout;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

class GridLayoutDemoV2 extends JFrame {

  // Components
  private JLabel xJLabel;
  private JLabel yJLabel;
  private JTextField xInput;
  private JTextField yInput;
  private JPanel xInputPanel;
  private JPanel yInputPanel;

  GridLayoutDemoV2() {
    // Set a suitable title for the frame.
    super("GridLayoutDemoV2");

    // Create two labels and two text fields.
    xJLabel = new JLabel("X coordinate:");
    yJLabel = new JLabel("Y coordinate:");
    xInput = new JTextField(5);
    yInput = new JTextField(5);
    xInput.setBackground(Color.yellow);
    yInput.setBackground(Color.yellow);
    xInputPanel = new JPanel();
    yInputPanel = new JPanel();

    // Get the content pane for the frame.
    Container contentPane = getContentPane();

    // Create and set a GridLayout with a 2x1 grid.
    contentPane.setLayout(new GridLayout(2, 1));

    // Construct the component hierarchy.
    xInputPanel.add(xJLabel);
    xInputPanel.add(xInput);
    yInputPanel.add(yJLabel);
    yInputPanel.add(yInput);
    contentPane.add(xInputPanel); // [0,0]
    contentPane.add(yInputPanel); // [1,0]

    // Terminate if the frame is closed.
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    // Show the GUI.
    pack();
    setVisible(true);
  }
}