import java.awt.Container;
import java.awt.FlowLayout;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

class PizzaWithGUIOnly extends JFrame {

  // Components.
  private JPanel panel1, panel2;

  // Radiobuttons for pizza sizes.
  JRadioButton smallPizza;
  JRadioButton mediumPizza;
  JRadioButton largePizza;

  // Checkboxes for pizza toppings.
  JCheckBox pizzaTopping1;
  JCheckBox pizzaTopping2;
  JCheckBox pizzaTopping3;
  JCheckBox pizzaTopping4;

  // Button to order a pizza.
  private JButton orderButton;

  PizzaWithGUIOnly() {
    // Set suitable title for the frame.
    super("Pizza Shack");

    // Create radiobuttons for the different pizza sizes.
    smallPizza = new JRadioButton("Small pizza");
    mediumPizza = new JRadioButton("Medium pizza");
    largePizza = new JRadioButton("Large pizza");
    largePizza.setSelected(true);

    // Create a ButtonGroup object for grouping the radio buttons.
    ButtonGroup group = new ButtonGroup();
    group.add(smallPizza);
    group.add(mediumPizza);
    group.add(largePizza);

    // Create a panel for pizza sizes.
    panel1 = new JPanel();
    panel1.add(smallPizza);
    panel1.add(mediumPizza);
    panel1.add(largePizza);

    // Create checkboxes for pizza toppings.
    pizzaTopping1 = new JCheckBox("Chicken");
    pizzaTopping2 = new JCheckBox("Pepperoni");
    pizzaTopping3 = new JCheckBox("Meat balls");
    pizzaTopping4 = new JCheckBox("Beef");
    pizzaTopping1.setSelected(true);

    // Create a panel for toppings.
    panel2 = new JPanel();
    panel2.add(pizzaTopping1);
    panel2.add(pizzaTopping2);
    panel2.add(pizzaTopping3);
    panel2.add(pizzaTopping4);

    // Create a button for ordering pizza.
    orderButton = new JButton("Order");

    // Get the content pane for the frame.
    Container contentPane = getContentPane();

    // Set layout manager for the content pane.
    contentPane.setLayout(new FlowLayout());

    // Construct the component hierarchy.
    contentPane.add(panel1);
    contentPane.add(panel2);
    contentPane.add(orderButton);

    // Terminate if the frame is closed.
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    // Show the GUI.
    pack();
    setVisible(true);
  }
}