import java.awt.Color;
import java.awt.Container;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JFrame;

class SimpleWindow1 extends JFrame {

  // (2) Components
  private JButton colorButton;        // the source
  private ExternalListener1 listener; // the listener

  // (3) Other fields
  private boolean colorToggle;

  SimpleWindow1() {
    // Set suitable title for the frame.
    super("Simple window");

    // Create a button.
    colorButton = new JButton("Change colour");

    // Get the content pane.
    Container contentPane = getContentPane();

    // Create and set a layout manager and add
    // the button to the content pane.
    contentPane.setLayout(new FlowLayout(FlowLayout.CENTER));
    contentPane.add(colorButton);

    // Create a listener and register it with the source (i.e. button)
    // to receive ActionEvents.
    listener = new ExternalListener1(this);               // (4)
    colorButton.addActionListener(listener);              // (5)

    // Terminate if the frame is closed.
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    // Show the GUI.
    pack();
    setVisible(true);
  }

  // Change background colour for the content pane.
  public void changeColor() {                             // (6)
    Container contentPane = getContentPane();
    if (colorToggle)
      contentPane.setBackground(Color.cyan);
    else
      contentPane.setBackground(Color.yellow);
    colorToggle = !colorToggle;
  }
}