import java.awt.Color;
import java.awt.Container;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JFrame;

class SimpleWindow3 extends JFrame {

  // Components
  private JButton colorButton;        // the source
  private ExternalListener3 listener; // the listener

  // Other fields
  private boolean colorToggle;

  SimpleWindow3() {
    // Set suitable title for the frame.
    super("Simple window 3");

    // Create a button.
    colorButton = new JButton("Change colour");

    // Get the content pane.
    Container contentPane = getContentPane();

    // Create and set a layout manager,
    // and add the button to the content pane.
    contentPane.setLayout(new FlowLayout(FlowLayout.CENTER));
    contentPane.add(colorButton);

    // Create listener and register it with the source (i.e. button)
    // to recieve ActionEvents.
    listener = new ExternalListener3(this);                    // (1)
    colorButton.addActionListener(listener);                   // (2)

    // Register the same listener with the source (i.e. the frame)
    // to recieve WindowEvents.
    addWindowListener(listener);                               // (3)

    // Terminate if the frame is closed.
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    // Show the GUI.
    pack();
    setVisible(true);
  }

  // Change background colour for the content pane.
  public void changeColor() {                                  // (4)
    if (colorToggle)
      getContentPane().setBackground(Color.cyan);
    else
      getContentPane().setBackground(Color.yellow);
    colorToggle = !colorToggle;
  }
}
