import java.awt.Color;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JButton;
import javax.swing.JFrame;

class SimpleWindow4 extends JFrame
                    implements ActionListener, WindowListener {       // (1)
  // Components.
  private JButton colorButton; // the source

  // Other fields.
  private boolean colorToggle;

  SimpleWindow4() {
    // Set suitable title for the frame.
    super("Simple window 4");

    // Create a button.
    colorButton = new JButton("Change colour");

    // Get the content pane.
    Container contentPane = getContentPane();

    // Create a layout manager and add button to the content pane.
    contentPane.setLayout(new FlowLayout(FlowLayout.CENTER));
    contentPane.add(colorButton);

    // Register the frame as listener with the source (i.e. button)
    // to receive ActionEvents.
    colorButton.addActionListener(this);                              // (2)

    // Register the listener (i.e. the frame) with the source (i.e. the frame)
    // to receive WindowEvent events.
    addWindowListener(this);                                          // (3)

    // Show the GUI.
    pack();
    setVisible(true);
  }

  // Change background colour for the content pane.
  private void changeColor() {
    if (colorToggle)
      getContentPane().setBackground(Color.cyan);
    else
      getContentPane().setBackground(Color.yellow);
    colorToggle = !colorToggle;
  }

  // Called when the user clicks the colour button.
  public void actionPerformed(ActionEvent event) {                    // (4)
    changeColor();
  }

  // Called when the user clicks on the window close box.
  public void windowClosing(WindowEvent event) {                      // (5)
    System.out.println("Terminating the program");
    dispose();
    System.exit(0);
  }

  // Stubs for unused methods from the WindowListener interface.         (6)
  public void windowClosed(WindowEvent event)      { }
  public void windowOpened(WindowEvent event)      { }
  public void windowIconified(WindowEvent event)   { }
  public void windowDeiconified(WindowEvent event) { }
  public void windowActivated(WindowEvent event)   { }
  public void windowDeactivated(WindowEvent event) { }
}