import java.awt.Color;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JFrame;

class SimpleWindow5 extends JFrame {                                  // (1)
  // Components
  private JButton colorButton;

  // Other fields
  private boolean colorToggle;

  SimpleWindow5() {
    // Set suitable title for the frame.
    super("Simple window 5");

    // Create a button.
    colorButton = new JButton("Change colour");

    // Get the content pane.
    Container contentPane = getContentPane();

    // Create and set a layout manager, and add a button to the content pane.
    contentPane.setLayout(new FlowLayout(FlowLayout.CENTER));
    contentPane.add(colorButton);

    // Register a listener (that implements a contract) with the button
    // to receive ActionEvents.
    colorButton.addActionListener(new ActionListener() {              // (2)
      public void actionPerformed(ActionEvent h) {                    // (3)
        changeColor();                                                // (4)
      }
    });

    // Register a listener (that extends a superclass) with the frame
    // to receive WindowEvents.
    addWindowListener(new WindowAdapter() {                           // (5)
      public void windowClosing(WindowEvent h) {                      // (6)
        terminateProgram();                                           // (7)
      }
    });

    // Show the GUI.
    pack();
    setVisible(true);
  }

  // Change background colour for the content pane.
  private void changeColor() {                                        // (8)
    if (colorToggle)
      getContentPane().setBackground(Color.cyan);
    else
      getContentPane().setBackground(Color.yellow);
    colorToggle = !colorToggle;
  }

  // Terminate the program.
  private void terminateProgram() {                                   // (9)
    System.out.println("Terminating the program.");
    dispose();
    System.exit(0);
  }
}