package game;    // File: game/Direction.java
enum Direction {
  UP(0, 1), LEFT(1, 0), DIAGONAL1(1, 1), DIAGONAL2(1, -1),
  DOWN(-UP.columnStep,-UP.rowStep),
  RIGHT(-LEFT.columnStep,-LEFT.rowStep),
  OPPOSITE_DIAGONAL1(-DIAGONAL1.columnStep,-DIAGONAL1.rowStep),
  OPPOSITE_DIAGONAL2(-DIAGONAL2.columnStep,-DIAGONAL2.rowStep);

  final static Direction[] DIRECTIONS
               = {UP, LEFT, DIAGONAL1, DIAGONAL2};
  final static Direction[] OPPOSITE_DIRECTIONS
               = {DOWN, RIGHT, OPPOSITE_DIAGONAL1, OPPOSITE_DIAGONAL2};

  int columnStep;
  int rowStep;

  Direction(int dx, int dy) {
    columnStep = dx;
    rowStep = dy;
  }

  Direction opposite() {
    return OPPOSITE_DIRECTIONS[this.ordinal()];
  }
}