package game; // File: game/IPlayer
/**
 A player that can perform moves on a GameBoard. Implementations of
 this interface can provide strategies for deciding which column to choose
 for each move.
 */
public interface IPlayer {
  /**
   Selects one of the eligible columns in the game board, and calls
   the dropPieceDownColumn() method on the GameBoard object.
   Player implementations can choose whether to perform the
   dropPieceDownColumn() call immediately, or at a later time.
   */
  void performMove(IPieceIdentity piece, GameBoard board);
}