package game;    // File: game/ParticipantIdentity.java

/** The identity of a participant in the game.  Objects of this class can be
    considered to be a collection of similar game pieces,
    and can also be considered to be the identity of the player
    that owns the collection of pieces. */
public class ParticipantIdentity implements IPieceIdentity {
  private IPlayer player;
  public String textRepresentation;

  public ParticipantIdentity() {
  }

  public ParticipantIdentity(IPlayer player, String textRepresentation) {
    this.player = player;
    this.textRepresentation = textRepresentation;
  }

  public void performMove(GameBoard board) {
    player.performMove(this, board);
  }
}