package game.swing;    // File: game/swing/EasySwingGame.java
import game.GameBoard;
import game.IPieceIdentity;

import java.awt.Color;

/**
 * An easy game in which one player plays against another player.
 **/
public class EasySwingGame {
  public static void main(String args[]) {
    GameSwingUI ui = new GameSwingUI();
    IPieceIdentity[] participants = new IPieceIdentity[] {
      new ComponentColorIdentity(new SwingPlayer(ui), Color.BLUE,
                                 "Player 1"),
      new ComponentColorIdentity(new SwingPlayer(ui), Color.YELLOW,
                                 "Player 2")
    };
    IPieceIdentity emptyCell = new ComponentColorIdentity(null, Color.GRAY,
                                                          "");
    GameBoard board = new GameBoard(participants, emptyCell, ui);
    ui.startUserInterface();
  }
}