package game.terminal;    // File: game/terminal/GameTextUserInterface.java
import game.AbstractUserInterface;

public class GameTextUserInterface extends AbstractUserInterface {
  protected void showGameBoard() {
    System.out.print(gameBoardAsText());
  }

  protected void showMessage(String text) {
    System.out.println(text);
  }

  private String gameBoardRowAsText(int row) {
    final int NUMBER_OF_COLUMNS = 7;
    final int LAST_COLUMN = NUMBER_OF_COLUMNS - 1;
    String rowText = "|";
    for (int column = 0; column < LAST_COLUMN; ++column)
      rowText += gameBoardCellAsText(column, row) + " ";
    return rowText + gameBoardCellAsText(LAST_COLUMN, row) + "|";
  }

  private String gameBoardCellAsText(int column, int row) {
    return identityAsText(board.pieceAt(column, row));
  }

  private String gameBoardAsText() {
    String text = " 0 1 2 3 4 5 6\n";
    final int TOPMOST_ROW = 5;
    for (int row = TOPMOST_ROW; row >= 0; --row)
      text += gameBoardRowAsText(row) + "\n";
    return text + "===============\n";
  }
}