package game.terminal;    // File: game/terminal/TerminalPlayer.java
import game.GameBoard;
import game.IPieceIdentity;
import game.IPlayer;

import java.util.Scanner;

public class TerminalPlayer implements IPlayer {
  public void performMove(IPieceIdentity piece, GameBoard board) {
    assert !board.isGameOver();
    board.dropPieceDownColumn(piece, requestColumnSelection(board));
  }

  private int requestColumnSelection(GameBoard board) {
    Scanner scanner = new Scanner(System.in);
    while (true) {
      System.out.print("Select a column [0-6]: ");

      if (scanner.hasNextInt()) {
        int column = scanner.nextInt();
        if (board.isValidColumnSelection(column)) {
          scanner.nextLine(); // Skip the rest of the line.
          return column;
        }
      }
      scanner.nextLine(); // Skip the rest of the line.
      System.out.println("Invalid column. Try again.");
    }
  }
}