package game.test;    // File: game/test/GameSimulator.java
import game.GameBoard;
import game.IPieceIdentity;
import game.ParticipantIdentity;

public class GameSimulator {
  public static final IPieceIdentity X_PIECE = new ParticipantIdentity();
  public static final IPieceIdentity O_PIECE = new ParticipantIdentity();
  public static final IPieceIdentity EMPTY_CELL = new ParticipantIdentity();

  public static GameBoard buildGameBoard(String moveSequence) {
    IPieceIdentity[] pieces = new IPieceIdentity[]{ X_PIECE, O_PIECE };
    GameBoard board = new GameBoard(pieces, EMPTY_CELL);
    for (int i = 0; i < moveSequence.length(); ++i) {
      int column = Integer.parseInt(moveSequence.substring(i, i+1));
      board.dropPieceDownColumn(board.nextPiece(), column);
    }
    return board;
  }
}