package museumPkg;

import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;

/**
 * Create a window to report an error.
 */
public class ErrorReportFrame extends JFrame implements ActionListener {

  protected JLabel messageLabel = new JLabel();
  protected JButton okButton = new JButton("OK");

  /**
   * Creates a window to show an error message.
   * @param message The error message shown in the window.
   */
  public ErrorReportFrame(String message) {
    super("MuseumItemException...");
    Container content = getContentPane();
    content.setLayout(new GridLayout(2, 1));

    messageLabel.setText(message);

    okButton.addActionListener(this);

    content.add(messageLabel);
    content.add(okButton);

    pack();
    setSize(150, 100);
    setVisible(true);

  }

  /**
   * Returns when okButton is clicked.
   */
  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == okButton) {
      setVisible(false);
      dispose();
    }
  }
}
