package museumPkg;
import java.io.Serializable;
/**
 * Class represents a museum item.
 */
public class MuseumItem implements Serializable {

  // Instance variables

  /** Reference number of the item. */
  private int refNum = 0;

  /** Name of the item. */
  private String name = "";

  /** Description of the item */
  private String description = "";

  // Constructors
  /**
   *  Initialise an item.
   *  @param ref  Reference number of the item.
   *  @param n    Name of the item.
   *  @param b    Description of the item.
   **/
  public MuseumItem(int ref, String n, String b) {
    refNum = ref;
    name = n;
    description = b;
  }

  /**
   *  Default constructor does not set any values for the intem.
   **/
  public MuseumItem() { }

  // Mutators

  /**
   *  Sets a new reference number for item.
   *  @param ref New reference number.
   **/
  public void setRefNum(int ref) {
    refNum = ref;
  }

  /**
   *  Sets a new name for the item.
   *  @param n New name.
   **/
  public void setName(String n) {
    name = new String(n);
  }

  /**
   *  Gives the item a new description.
   *  @param desc new description
   **/
  public void setDescription(String desc) {
    description = new String(desc);
  }

  // Selectors
  /**
   * Returns reference number for the item.
   * @return Referanse number.
   **/
  public int getRefNum() {
    return refNum;
  }

  /**
   * Returns the name of the item.
   * @return The name.
   **/
  public String getName() {
    return name;
  }

  /**
   * Returns the description of the item.
   * @return The description.
   **/
  public String getDescription() {
    return description;
  }

  /**
   *  Determine whether two items are identical.
   *  Overrides the method from the Object class.
   *  @return true items are identical.
   **/
  public boolean equals(Object item) {
    return (refNum == ((MuseumItem) item).getRefNum());
  }

  /**
   *  Overrides the method from the Object class.
   *  @return String Representation of the item.
   **/
  public String toString() {
    return (refNum + " -- " + name + " -- " + description);
  }

  /**
   *  Print item to the terminal window.
   */

  public void print() {
    System.out.println(this);
  }
}
