package museumPkg;

/**
 * Create a new window to register a new item.
 */
public class NewItemFrame extends AbstractItemFrame {

  /**
   * "Overrides" the runButton from the superclass AbstractItemFrame.
   */
  public NewItemFrame(MainMuseumWindow mainWindow) {
    super(mainWindow);
    setTitle("New Museum Item");
    runButton.setText("Insert");
  }

  /**
   * Ovverides the method from the superclass AbstractItemFrame.
   * Registers a new item in the museum.
   * @exception MuseumItemException If error during insertion.
   */
  void doAction() throws MuseumItemException {
    Museum museum = mainWindow.getMuseum();
    MuseumItem item = new MuseumItem(getItemReferenceNum(), getItemName(),
                                     getItemDescription());
    museum.registerItem(item);
    removeFrame();
  }
}
