package museumPkg;

/**
 * Create a window to remove an item from the museum.
 */
public class RemoveItemFrame extends AbstractItemFrame {

  /**
   * "Overrides" the runButton from the superclass AbstractItemFrame.
   * Name and description fields cannot be specified when deleting.
   */
  public RemoveItemFrame(MainMuseumWindow mainWindow) {
    super(mainWindow);
    setTitle("Delete Museum Item");

    runButton.setText("Delete");
    nameField.setEditable(false);
    descriptionField.setEditable(false);
  }

  /**
   * Ovverides the method from the superclass AbstractItemFrame.
   * Removes a new item in the museum.
   * @exception MuseumItemException If error during removal.
   */
  void doAction() throws MuseumItemException {
    try {
      Museum museumet = mainWindow.getMuseum();
      museumet.removeItem(museumet.findItem(getItemReferenceNum()));
      removeFrame();
    } catch (NullPointerException e) {
      throw new MuseumItemException("Item not found");
    }
  }
}
